package  
{
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	
	public class xMultiGrid 
	{
			public var topCell:xCell;
		public var grids:Vector.<xGrid>;
		public var numGrids:Number;
		
		//todo:
		//position of grid to be changeable(?)
			public var cx:Number = 0;
			public var cy:Number = 0; //used as cz also (grid is 2D)
			
		public function xMultiGrid(width_:Number, height_:Number, minxshift_:Number, minyshift_:Number, levels_:Number) 
		{
			
			
			//trace("multigrid ", width_, height_,1 << minxshift_,1<<minyshift_,levels_ );
			
			if (width_ < 512) width_ = 512;
			if (height_ < 512) height_ = 512;
			
			if (minxshift_ < 5) minxshift_ = 5;
			if (minyshift_ < 5) minyshift_ = 5;
			
			if (minxshift_ > 12) minxshift_ = 12;
			if (minyshift_ > 12) minyshift_ = 12;
			
			if (levels_ < 1) levels_ = 1;
			if (levels_ > 6) levels_ = 6;
			
			numGrids = levels_;
			
			grids = new Vector.<xGrid>(numGrids, true);
			topCell = new xCell();
	
			for (var i:Number = 0; i < numGrids; i++)
			{
				var perx:Number = Math.floor(width_ / (1 << minxshift_)) + 1;
				var pery:Number = Math.floor(height_ / (1 << minyshift_)) + 1;
				
				//trace("making grid ", perx, pery);
				
				grids[i] = new xGrid(perx, pery, minxshift_, minyshift_);
				
				minxshift_++;
				minyshift_++;
			}//next i
			
		}//ctor
		
		public function clear():void
		{
			var i:int;
			for (i = 0; i < grids.length; i++)
			{
				grids[i].clear();
			}//next i

			grids = null;
		}//getrid
		
		
		//rectangle query
		public function doQuery(x0:Number, y0:Number, w_:Number, h_:Number):xCell
		{
			//set topcell as the query first cell
			topCell.setAsLast();
			
			//new -- consider position
			//commenting out seem to eliminated a problem .. what the hell???
			//bug was somewhere else -- putinXY ignored the position
				x0 -= cx;
				y0 -= cy
			
			//make sure rect is valid
			if (x0 < 0) { x0 = 0; }
			if (y0 < 0) { y0 = 0; }
			
			var x1:Number = x0 + w_;
			var y1:Number = y0 + h_;
			
			//furtheropt
			//(not sure if eliminating the additions with additional local values would improve any speed)
			
			var grid_:xGrid;
			
			for (var i:int = 0; i < numGrids; i++)
			{
				grid_ = grids[i];
				grid_.doQuery(x0, y0, x1, y1);		
			}//next i
				
				xCell.lastc.next = null; //important
				
			return this.topCell; //always return this one -- start of the query cell
		}//doquery
		
		//put in actor into multigrid
		public function putInXY(a:xActor):void
		{
			var grid_:xGrid;
			for (var i:int = 0; i < numGrids; i++)
			{
				grid_ = grids[i]; 
				if ( grid_.putInXY(a) ) return;
			}//next i

			
			//couldnt put in grids put it in the topcell
				topCell.addActor(a);
		}//putin
		
		//put in actor into multigrid
		public function putInXZ(a:xActor):void
		{
			var grid_:xGrid;
			for (var i:int = 0; i < numGrids; i++)
			{
				grid_ = grids[i]; 
				if ( grid_.putInXZ(a) ) return;
			}//next i

			
			//couldnt put in grids put it in the topcell
				topCell.addActor(a);
		}//putin
		
		public function setPos(x_:Number, y_:Number):void
		{
			var g:xGrid;
			var i:int;
			
			cx = x_;
			cy = y_;
			
			for (i = 0; i < numGrids; i++)
			{
				g = grids[i];
				g.cx = cx;
				g.cy = cy;
			}
		
		}//setpos
		
		public function renderMultiGrid(to_:BitmapData, sx_:Number, sy_:Number):void
		{
			
			//iterate through and draw all grids
			for (var i:Number = 0; i < numGrids; i++)
			{
				grids[i].drawGrid(to_, sx_-cx, sy_-cy,i+1);
			}//next i
		}//renmultigrid
		

		
	}//classend

}

import flash.display.BitmapData;
import flash.geom.Rectangle;

internal class xGrid
	{
		
		public var cells:Vector.<xCell>;
		public var numCells:int; // Number; //precalc xcells * ycells
		
		//public var cpx:Number;
		//public var cpy:Number;
		
		//number of cells
		public var xcells:int; // Number;
		public var ycells:int; // Number;
		
		//cell size stored in shift 
		//5 is 32 as the minimum allowed
		public var shift_x:int; //Number;
		public var shift_y:int; // Number;
		
		public var cell_size_x:Number; //precalculated (1 << shift_x)
		public var cell_size_y:Number;
		
		public var grid_size_x:Number; //precalculated (cell_size_x * xcells)
		public var grid_size_y:Number;
		
		public var cx:Number = 0;
		public var cy:Number = 0;
		
		//todo -- maybe im over optimising?
		
		//cells per x, cells per y
		//note - these will be put on the number of two
		//so could be optimised by shifting
		//so giving this 4 results in 2^4 cells, aka 2*2*2*2 = 16
		//public function xGrid(cpx_:Number=4, cpy_:Number=4) 
		
		public function xGrid(xcell_:Number, ycell_:Number, shiftx_:Number, shifty_:Number)
		{
		
			
			xcells = xcell_;
			ycells = ycell_;
			
			if (xcells <= 0) xcells = 1;
			if (ycells <= 0) ycells = 1;
			
			numCells = xcells * ycells;
			
			cells = new Vector.<xCell>(numCells, true);
			
			//for (var ce:Number = 0; ce < numCells; ce++)
			for (var ce:int = 0; ce < numCells; ce++)
			{
				cells[ce] = new xCell();
			}//next ce
			
			//trace("numCells: " + numCells);
			
			
			shift_x = shiftx_;
			shift_y = shifty_;
			
			if (shift_x < 5) shift_x = 5;
			if (shift_y < 5) shift_y = 5;
			
			//maximum size is 2^16 -- 65536 -- should be enough for now
			if (shift_x > 16) shift_x = 16;
			if (shift_y > 16) shift_y = 16;
			
			cell_size_x = 1 << shift_x;
			cell_size_y = 1 << shift_y;
			
			grid_size_x = cell_size_x * xcells;
			grid_size_y = cell_size_y * ycells;
		}//ctor
		
		public function clear():void	{		cells = null; }
		
		
		public function doQuery(x0:int, y0:int, x1:int, y1:int):void
		{
			x0 >>= shift_x;
			y0 >>= shift_y;
			
			x1 >>= shift_x;
			y1 >>= shift_y;
			
			x1 += 1;
			y1 += 1;
			
			
			//make sure it is in limits
			//not x0 and y0 is checked in the multigrid doQuery(..) already
			if (x1 > xcells) x1 = xcells;
			if (y1 > ycells) y1 = ycells;
	
			var yt:int;
			var gy:int;
			var gx:int;

			for (gy = y0; gy < y1; gy++)
			{
				yt = gy * xcells;

				for (gx = x0; gx < x1; gx++)
				{
					cells[yt + gx].at2(); //add to end of list if has any actors in it
				}//next gx
			}//next gy

		}//doquery
		
		
		public function putInXY(a:xActor):Boolean
		{
			//x tile to put in
				var px:int = (a.cx - (a.xrad)-cx) >> shift_x;
			
				//is it valid
					if (px < 0 || px >= xcells) return false;
					
				//is it the same as the other corner
					if (px !=  ((a.cx  + (a.xrad)-cx) >> shift_x) ) return false;
			
			//y tile to put in
				//var py:Number = (a.cy - (a.yrad)) >> shift_y;
				var py:int = (a.cy - (a.yrad)-cy) >> shift_y;
			
				//is it valid
					if (py < 0 || py >= ycells) return false;
				
				//is same as other corner
					if (py != ((a.cy + (a.yrad)-cy) >> shift_y) ) return false;
			
			//put in cell at px, py
			
				cells[ ((py * xcells) + px) ].addActor(a);
			
			return true;
		}//putin

		
		
		
		
		public function putInXZ(a:xActor):Boolean
		{
			//x tile to put in
				var px:int = (a.cx - (a.xrad) - cx) >> shift_x;
			
				//is it valid
					if (px < 0 || px >= xcells) return false;
					
				//is it the same as the other corner
					if (px !=  ((a.cx  + (a.xrad) - cx) >> shift_x) ) return false;
			
			//y tile to put in
				var py:int = (a.cz - (a.zrad) - cy) >> shift_y;
			
				//is it valid
					if (py < 0 || py >= ycells) return false;
				
				//is same as other corner
					//if (py != ((a.cy + (a.yrad) - cy) >> shift_y) ) return false;
					if (py != ((a.cz + (a.zrad) - cy) >> shift_y) ) return false;
				
			//put in cell at px, py
			
				cells[ ((py * xcells) + px) ].addActor(a);
			
			return true;
		}//putin
		
		
		
		
		static public var tempRect:Rectangle = new Rectangle();
		public function drawRect(to:BitmapData, ax:Number, ay:Number, aw:Number, ah:Number, c:uint=0xFF0000):void
		{
			tempRect.x = ax;
			tempRect.y = ay;
			tempRect.width = aw;
			tempRect.height = ah;
			to.fillRect(tempRect, c);
		}//drawrect
		
		
		//no need to optimise this one -- its for debugging purposes anyway
		public function drawGrid(to_:BitmapData, sx_:Number, sy_:Number, wid:Number = 1):void
		{
			
			//start and end cell
			
			//dont even want to know why it works with int but not floor
			var stx:int =(sx_ / cell_size_x) ; // >> shift_x; //startx
			var sty:int = (sy_ / cell_size_y) ;// >> shift_y; //starty
				
			var enx:Number = 2 + ((to_.width) >> shift_x); //endx
			var eny:Number = 2 + ((to_.height) >> shift_y); //endy
		
		
			
			//offset
			var offx:int = sx_ % cell_size_x;
			var offy:int = sy_ % cell_size_y;
			
			//where to draw
			var dx:Number; //= offx;
			var dy:Number; //= offy;
			
			//cell drawn
			var tx:Number = stx;
			var ty:Number = sty;
			
			var tymulwid:Number = 0;
			var gy:Number;
			var gx:Number;
			
			for ( gy=0; gy < eny; gy++, ty++) //, dy += cell_size_y)
			{
				if (ty < 0 || ty >= ycells) continue;
				
				//dx = offx;
				dy = (gy * cell_size_y) - offy;
				//dy += cy;
				tx = stx;
			
				tymulwid = ty * xcells;
				
				for ( gx = 0; gx < enx; gx++, tx++) //, dx += cell_size_x)
				{
					if (tx < 0 || tx >= xcells) continue;
					
					dx = (gx * cell_size_x) - offx;
					//dx += cx;
					
					if ( cells[tymulwid + tx].num > 0)
					{
						drawRect(to_, dx + 9, dy + 9, cell_size_x -18, cell_size_y -18, 0xFF0000FF | (cells[tymulwid + tx].num << 16));
					}//endif
					
					
					//.drawRect(to_, dx, dy, cell_size_x, cell_size_y, 0);
					drawRect(to_, dx, dy, cell_size_x, wid, 0);
					
					drawRect(to_, dx, dy, wid, cell_size_y, 0);
					
					
					drawRect(to_, dx, dy+cell_size_y, cell_size_x, wid, 0);
					
					drawRect(to_, dx+cell_size_x, dy, wid, cell_size_y, 0);
				}//next gx
			}//next gy
		
		}//drawgrid
		
		
	}//classend