package 
{
    import flash.display.Bitmap;
    import flash.display.BitmapData;
	  import flash.display.Graphics;
	  import flash.display.Sprite;
	  import flash.events.Event;
	import flash.events.KeyboardEvent;
    import flash.geom.Rectangle;
    import flash.text.TextField;

    import flash.utils.getTimer;
    
    
	public class xPathFind 
  {
      
      public var vecZone:Vector.<xZone> = new Vector.<xZone>;
 
      public var vecCol:Vector.<int> = null; //column
 
        public var maxOpen:int; 
        public var vecOpen:Vector.<xZone> = new Vector.<xZone>(8192, false);
        public var curFrame:int = 0;
        public var it:int = 0;
        
        
        public var startx:Number = 0;
        public var starty:Number = 0;
        public var endx:Number = 0;
        public var endy:Number = 0;

        public var start:xZone;
        public var goal:xZone;
        public var lastZone:xZone;
        public var zoneFlag:int = 0;
        
        public var bFinish:Boolean = true;
        
        public var debLayer:Sprite = new Sprite();
        
        //note -- need to take the cell size into account for this one 
        //.. or resize the zones to be pixel size (?)
        //eg startPath(pos.x/cw, pos.y/ch,  goal.x/cw, goal.y/ch)
        
        //todo -- the actor scheduling should be a different class that uses this one
        
        
        //todo -- return codes -- e.g. if in same zone, or unreachable etc
        //and you can always use startPath2 if you want to force it anyway
        //remember that getpath uses [startx,starty] and [endx, endy] instead the middle of the zones to return your path
        //also its wise to adjust the coordinates based on character size first (e.g. take end goal out of wall)
        public function startPath(sx:Number, sy:Number, ex:Number, ey:Number, zf:int):int
        { 
          var a:xZone;
          var b:xZone;
          
          a = getZone(sx, sy);
          b = getZone(ex, ey);
        
          if (a == null) { return -1; } //no start
          if (b == null) { return -2; } //no goal
          if (a == b) { return 0; }     //same zone
          if (a.group != b.group) { return -99; } //unreachable //(maybe it should be the same for no goal?)
          
            startx = sx;
            starty = sy;
            
            endx = ex;
            endy = ey;
          
            zoneFlag = zf;

            startPath2(a, b);
        
          return 1;
        }//startpath
        
        
        //so far this might be the slowest one (goes through all zones)
        public function getZone(wx:Number, wy:Number):xZone
        {
          var i:int;
          var num:int;
          var a:xZone;
          
          num = vecZone.length;
          
          for (i = 0; i < num; i++)
          {
            a = vecZone[i];
            if (wx < a.cx) { continue;}
            if (wy < a.cy) { continue; }
            if (wx > a.cx+a.cw) { continue; }
            if (wy > a.cy+a.ch) { continue; }
            
            return a;
          }//nexti
          
          return null;
        }//getzone
        
        
        public function startPath2(startzone:xZone, goalzone:xZone):void
        {
        
            bFinish = false;
            lastZone = null;
        
            start = startzone;
            goal = goalzone;
            
            curFrame += 1;
        
            vecOpen[0] = start;
            it = 1;
            
            start.frame = curFrame;
            start.parent = null;
            start.cost = 0; //set first zone cost to 0
            
        
        }//startpath2
        
        
        //maybe findpath could be used with arbitary open vector
        //so the path finding can be run on parrallel or something
        //but i personally dont want to use it like that so whatever
        
        public function findPath(numstep:int=256):void
        {
            if (bFinish) return; 
        
            var i:int;
            var a:xZone;
            var k:int;
            var vec:Vector.<xZone>;
            var b:xZone;
            var num:int;
            var nk:int;
            
            var mcost:Number;
            
            //graphics.lineStyle(2, 0xFF0000);
            
            //no function calls, no worry about overflowing the stack 
            
            //debug
             if (debLayer != null) 
                     {
                      if (debLayer.parent != null) { debLayer.parent.removeChild(debLayer); }
                      debLayer = null;
                     }
                     debLayer = new Sprite();
            
            for (i = 0; i < numstep; i++)
            {
                if (it <= 0)
                { 
                  bFinish = true;
                  lastZone = null; 
                 // trace("path not found"); 
                  return;
                } //endif
                
                //todo -- check vecopen size
                //get node with lowest cost
                    //mcost = 99999999999999999999999999;
                    mcost = 4503599627370496; 
                    a = vecOpen[0];
                    for (k = 0; k < it; k++)
                    {
                        b = vecOpen[k];
                        if (b.cost < mcost)
                        {
                           mcost = b.cost;
                           a = b;
                           nk = k;
                        }
                    }//nextk
                    
                  //take out the node from the open
                    vecOpen[nk] = vecOpen[it - 1];
                    it -= 1;
                
                   // graphics.drawCircle(a.mx * 8, a.my * 8, 12);
    
                //check if goal is reached
                    if (a == goal)
                    { 
                     // trace("found path ");  
                     // trace(" it ", it, " i ", i); 
                      lastZone = a;
                      bFinish = true;
                      //drawPath();
                      return; 
                    }//endif
                
                
                //add neighbours of node to open
                
                  vec = a.vecNext;
                  num = vec.length;
                  
                  for (k = 0; k < num; k++)
                  {
                     b = vec[k];
                     if (b.frame == curFrame) { continue; } 
                     b.frame = curFrame;
                     //its important to add the cost of the road so far
                     //otherwise we become a get longest path sometime algorithm
                     //squared length check has the same result as non squared (aka no need for sqrt)
                     //b.cost = mcost + ((a.mx - b.mx) * (a.mx - b.mx) + (a.my - b.my) * (a.my - b.my));
                    //using square root fixes some paths (but im baffled why)
                    //maybe not square rooting adds some error(?)
   
                    //the start position is special
                    //we need to consider our start point instead of the zone center
                    if (a == start)
                    {
                        b.cost = mcost + Math.sqrt((startx - b.mx) * (startx - b.mx) + (starty - b.my) * (starty - b.my));
                    }
                    else
                    {
                        //funnily enough now its less precise (?)
                          b.cost = mcost + Math.sqrt((a.mx - b.mx) * (a.mx - b.mx) + (a.my - b.my) * (a.my - b.my));

                          //add cost for walls (so far double is used so no worry about overflow)               
                          if ((b.zt & zoneFlag) == 0) { b.cost+= 999999999;}

                        }//endif
              
                     
                    
                    //problem is we are using rectangles
                    //and the cost is distance to a point
                    //so we would need to figure out the closest point to figure out the distance
                    //e.g. check if the zone is above or below us 
                    //because if its right above we need to use the same mx as ours
                    //and if its left or right its the same y
                    //still thats not the actual position of the portal between the two but closer(i guess)
                    
                    //if that doesnt work
                    //solution B is to make more zones and make them more squary
                    
                    //its still a good idea to limit the zone sizes
                    
                     b.parent = a;
                     
                     //debug
                    /*
                     var tf:TextField;
                     tf = new TextField();
                     tf.text = " " + int(b.cost);
                     tf.x = b.mx;
                     tf.y = b.my;
                     tf.mouseEnabled = false;
                     debLayer.addChild(tf);
                     */
                     //still some cases the ordering is not good (or the cost?)
                     //so it chooses the longer path
                     //but im not sure
                     
                     
                     //todo -- check if at the meeting of the two zones
                     //would we overlap the backdrop
                     //(testing if the opening is big enough might be enough but im not sure
                     //testing the size of the zones will not be enough
                     
                      vecOpen[it] = b;
                      it += 1;
                  }//nextk
                
                
            }//nexti
            
           // trace(" it ", it, " i ", i);
            
        }//findpath
        
        
        
        //usage:
        //buildzone -- use it to refresh the zone data for path finding
        //startpath -- then use findpath until bFinished
        //then claim your finished path
        //note: string pulling is not performed in this one
        //its expected to be done in realtime
        public function getPath():Vector.<xPoint>
        {
            var a:xZone;
            var b:xZone;
            
            
            var vec:Vector.<xPoint>;
            
            vec = new Vector.<xPoint>(0, false);
            
            a = lastZone;
            
           // graphics.lineStyle(4, 0x00FF00, 1);
            
            if (a == null) { return null; }
           
          
            var prevx:Number;
            var prevy:Number;
            
            var kx:Number;
            var ky:Number;
            
            var ry:Number;
            var sy:Number;
            
            prevx = -1;
            prevy = -1;
             
            kx = a.mx;
            ky = a.my;
            
            
            
              //  graphics.moveTo(a.mx * 8, a.my * 8);
                
                vec.push(new xPoint(endx, endy) );
            while (a != null)
            {
              
                b = a;
                a = a.parent;
                 
                if (a == null) { break; }
                
              
             
                if (a.cx + a.cw-0.1 < b.cx)
                {
                    
                    kx = a.cx + a.cw;
                    
                      ry = a.cy > b.cy ? a.cy : b.cy;
                    sy = a.cy + a.ch < b.cy + b.ch ? a.cy + a.ch : b.cy + b.ch;
                    
                    ky = (ry + sy) * 0.5; 
                    
                    //correction -- visit the center if both portals are on the same side
                    //todo -- sometimes it doest it, sometimes it dont (???)
                    //maybe we need a.mx in some(?)
                        if (prevx == kx) { vec.push(new xPoint(b.mx, b.my)); }
                    
                    //  graphics.lineTo(kx * 8, ky * 8);
                    vec.push(new xPoint(kx, ky) );
                    
                }
                else if (b.cx + b.cw-0.1 < a.cx) 
                {
                    kx = b.cx + b.cw;

                    ry = a.cy > b.cy ? a.cy : b.cy;
                    sy = a.cy + a.ch < b.cy + b.ch ? a.cy + a.ch : b.cy + b.ch;
                    
                    ky = (ry + sy) * 0.5; 
                    
                            if (prevx == kx) { vec.push(new xPoint(b.mx, b.my)); }
                        
                     // graphics.lineTo(kx * 8, ky * 8);
                      vec.push(new xPoint(kx, ky) );
                     
                }
                else if (a.cy + a.ch-0.1 < b.cy)
                {
                    ky = a.cy + a.ch;
                    
                    ry = a.cx > b.cx ? a.cx : b.cx;
                    sy = a.cx + a.cw < b.cx + b.cw ? a.cx + a.cw : b.cx + b.cw;
                    
                    if (prevy == ky) { vec.push(new xPoint(b.mx, b.my)); }
                    
                    kx = (ry + sy) * 0.5; 
                    // graphics.lineTo(kx * 8, ky * 8);
                      vec.push(new xPoint(kx, ky) );
                }
                else //b.cy+b.ch < a.cy
                {
                      ky = b.cy + b.ch;
                    
                    ry = a.cx > b.cx ? a.cx : b.cx;
                    sy = a.cx + a.cw < b.cx + b.cw ? a.cx + a.cw : b.cx + b.cw;
                 
                      if (prevy == ky) { vec.push(new xPoint(b.mx, b.my)); }
                    
                    kx = (ry + sy) * 0.5; 
                    // graphics.lineTo(kx * 8, ky * 8);
                     vec.push(new xPoint(kx, ky) );
                }
                
                prevx = kx;
                prevy = ky;
  
            }//wend
            
            
              //graphics.lineTo(b.mx * 8, b.my * 8);
               vec.push(new xPoint(startx, starty) );
              
              //http://help.adobe.com/en_US/FlashPlatform/reference/actionscript/3/Vector.html
              //meh just reverse it
              //	reverse():Vector.<T>
              // Reverses the order of the elements in the Vector.
              
              return vec.reverse();
        }//drawpath
        
  


   
     

//  public function buildZone(vecGrid:Vector.<int>, mw:int, mh:int,  cellw:Number=1.0, cellh:Number=1.0):void
  
        public function buildZone(tmap:xTileMap):void
         {
          var q:xQuad;
          var vqnum:int;
          var i:int;
          var k:int;
          var mw:int;
          var mh:int;

          mw = tmap.mw;
          mh = tmap.mh;
    
            qcell = 16;
            qwidth = Math.ceil(mw / qcell) + 1; 
            qheight = Math.ceil(mh / qcell) + 1;
            
            vqnum = qwidth * qheight;
            vecQuad = new Vector.<xQuad>(vqnum, false);

            for (i = 0; i < qheight; i++)
            {
              for (k = 0; k < qwidth; k++)
              {
                q = new xQuad();  
                q.tx = i*qcell;
                q.ty = k*qcell;
                q.dirty = 1;             

                vecQuad[(i*qwidth)+k] = q;
              }//nextk
            }//nexti


            cw = tmap.cw;
				    ch = tmap.ch;

  	        rebuildQuad(tmap);

        }//buildzone2


        
        //note -- qa == qb is special
        
        public function conQuad(qa:xQuad):void
        {
            var a:xZone;
            var b:xZone;
            
            var i:int;
            var k:int;
            
            var num:int;

            
            var vec:Vector.<xZone>;
    
            vec = qa.vec;
   
            
            num = vec.length;

            
            for (i = 0; i < num; i++)
            {
                a = vec[i];
                
                for (k = i+1; k < num; k++)
                {
                   
                    b = vec[k]; //just looking up adds 100 ms
                    
                    //these add 100ms
                    //removing the additions didnt improve anything
                    //removing them altogether adds 500ms
                    
                    //ok so these tests save a lot with early out
                    if (a.cx2 < b.cx) { continue; }
                    if (b.cx2 < a.cx) { continue; } 
                    if (a.cy2 < b.cy) { continue; }
                    if (b.cy2 < a.cy) { continue; }
                    
                    //new -- corner fix
                     if ((a.cx2) == b.cx && (a.cy2) == b.cy) { continue; }
                     if ((a.cx2) == b.cx && (b.cy2) == a.cy) { continue; }
                     if ((b.cx2) == a.cx && (b.cy2) == a.cy) { continue; }
                     if ((b.cx2) == a.cx && (a.cy2) == b.cy) { continue; }
                     
                         //doesnt add extra
                        a.vecNext.push(b);
                        b.vecNext.push(a);
                
                }//nextk                
            }//nexti
           
            
        }//conquad
        
        
        public function conQuad2(qa:xQuad, qb:xQuad):void
        {
            var a:xZone;
            var b:xZone;
            
            var i:int;
            var k:int;
            
            var num:int;
            var numk:int;
            
            var veca:Vector.<xZone>;
            var vecb:Vector.<xZone>;
            
            
            veca = qa.vec;
            vecb = qb.vec;
            
            num = veca.length;
            numk = vecb.length;
            
            for (i = 0; i < num; i++)
            {
                a = veca[i];
                
                for (k = 0; k < numk; k++)
                {
                   // if (i == k) { continue; } //no longer needed
                   
                    b = vecb[k]; //just looking up adds 100 ms
                    
                    //these add 100ms
                    //removing the additions didnt improve anything
                    //removing them altogether adds 500ms
                    
                    //ok so these tests save a lot with early out
                    if (a.cx2 < b.cx) { continue; }
                    if (b.cx2 < a.cx) { continue; } 
                    if (a.cy2 < b.cy) { continue; }
                    if (b.cy2 < a.cy) { continue; }
                    
                    //new -- corner fix
                     if ((a.cx2) == b.cx && (a.cy2) == b.cy) { continue; }
                     if ((a.cx2) == b.cx && (b.cy2) == a.cy) { continue; }
                     if ((b.cx2) == a.cx && (b.cy2) == a.cy) { continue; }
                     if ((b.cx2) == a.cx && (a.cy2) == b.cy) { continue; }
                     
                         //doesnt add extra
                        a.vecNext.push(b);
                        b.vecNext.push(a);
                
                }//nextk                
            }//nexti
            
            
        }//conquad2
        
        
        
        public var mr:xMegaRand = new xMegaRand();
        public function genGroup():void
        {
            var temp:Vector.<xZone>;
            var ti:int;
            var vec:Vector.<xZone>;
            var numk:int;
            var num:int;
            var i:int;
            var k:int;
            var a:xZone;
            var b:xZone;
            var group:int;
            var debcol:uint;
            var zt:int;

            mr.setSeed(1);

            //for now its not grouping by zonetypes
            //but by reachability
            //aka-- need to figure out unreachable zones (?)
            
            group = 1; //dont start at 0 or its infinite loop
            
            num = vecZone.length;
            
            temp = new Vector.<xZone>(num*4, false);

            
            for (i = 0; i < num; i++)
            {
                a = vecZone[i];
            
                if (a.group != 0) { continue; }

                debcol = 0x888888 +  mr.getRand() * 0x777777;//  (Math.random() * 0x777777);
                group += 1;
                ti = 0;
                
                zt = a.zt;

                temp[0] = a;
                ti = 1;
                
                while (ti > 0)
                {
                    a = temp[ti - 1];
                    ti -= 1;
                    
                    //if (a.group != 0) { continue;}
                    a.group = group;
                    a.col = debcol;
                                      
                    vec = a.vecNext;
                    numk = vec.length;
                    
                    for (k = 0; k < numk; k++)
                    {
                        b = vec[k];
                        if (b.group != 0) { continue;}
                      //  if (b.zt != zt) { continue; }
                        temp[ti] = b;
                        ti += 1;                    
                    }//nextk
                
                }//wend
                
            
            }//nexti    
            
            trace("number of zone groups: " + (group-1));
            
        }//gengroup 
		
    
         //compacted these small functions according to my eternal battle with readability
         
         //todo -- replace getclosex class too (so eliminate function calls too)
        public function getClosex(vec:Vector.<int>, col:Vector.<int>, mw:int, ax:int, ay:int):int
        {
            var k:int;   var yt:int;     var t:int;
            yt = ay * mw; 
            for (k = ax; k < mw; k++)
            {   
                t = vec[yt + k];
                if (t <= 0) { return k; } 
                
                t = col[k];
                if (t >= ay) { return k; }        
            }
            return mw;
        }//getclose
        
  
        public function copyVec(vec:Vector.<int>):Vector.<int>
        {
            var i:int;        var num:int;        var ret:Vector.<int>;  
            num = vec.length;  ret = new Vector.<int>(num, false);
            for (i = 0; i < num; i++)   { ret[i] = vec[i]; }
            return ret;
        }//copyvec
        
        
        public function setRect(vec:Vector.<int>,mw:int,mh:int,  ax:int, ay:int, aw:int, ah:int, c:int):void
        {
            var ex:int;   var ey:int;  var i:int;  var k:int;  var yt:int;  
            ex = ax + aw;   ey = ay + ah;
            if (ax < 0) { ax = 0;  }        if (ay < 0) { ay = 0;  }
            if (ex > mw) { ex = mw;   }     if (ey > mh) { ey = mh;    }
            if (ax >= mw) { return;  }      if (ay >= mh){ return;  }
            if (ex < 0) { return;  }        if (ey < 0) { return;  }
            for (i = ay; i < ey; i++) { yt = i * mw;  for (k = ax; k < ex; k++) {    vec[yt+k] = c;  }  }
        }//setrect 
		
		
		public function setDirty(wx:Number, wy:Number):void
		{
			//set quadrant that has world coordinates dirty
      
			  var qcw:Number;
			  var qch:Number; 
			  
			  qcw = qcell * cw;
			  qch = qcell * ch;
			  
			  var tx:int;
			  var ty:int;
			  
			  tx = Math.floor(wx / qcw);
			  ty = Math.floor(wy / qch);
			  
			  var q:xQuad;
			  
			  q = vecQuad[ (ty * qwidth) + tx];
			  q.dirty = 1;
      
		}//setdirty
    
    //so only part left is making sure the first buildzone also saves the vecquad generated
    
    public var qcell:int = 16; //a quadrant is qcell*qcell in size
    public var qwidth:int = 0;
    public var qheight:int = 0;
    public var vecQuad:Vector.<xQuad>;
    public var cw:Number = 0;
    public var ch:Number = 0;
		
	//rebuild dirty quads (and connections with their neighboring quads)
		public var tempQuad:Vector.<xQuad> = new Vector.<xQuad>(1024, false);
		public function rebuildQuad(tmap:xTileMap):void //vecGrid:Vector.<int>, mw:int, mh:int):void
		{
			var a:xQuad;
			var i:int;
			var num:int;
			var it:int;
			var yt:int;
			var k:int;
			var numk:int;
			var qa:xQuad;
			var qb:xQuad;
			var vec:Vector.<xQuad>;
			var start:int;
			
			var ndirt:int = 0;
			var nconn:int = 0;
			
			
			start = getTimer();
			
			
			vec = vecQuad;
			
			it = 0;
			
			
			num = vec.length;
			
			for (i = 0; i < num; i++)
			{
				a = vec[i];
				
				if (a.dirty <= 0) { continue; }
				ndirt += 1;
				tempQuad[it] = a;
				it += 1;
					
				a.clear();
				makeZoneQuad(a, tmap); // vecGrid, mw, mh, cw, ch);
			}//nexti
      
			  //clean up all quads
		 //(does this slow things down? it shouldnt be)
		 var cstart:int;
		 cstart = getTimer();
			  num = vec.length;
				for (i = 0; i < num; i++)
					{
						a = vec[i];
						a.clean();
					}//nexti
		trace(" cleantime " + (getTimer() - cstart) + " ms" );
			//go through all quads 
			//if a nearby quad has changed then rebuild connections to it
			
			//.. just add connections and clean up everything at the end anyway(?)
			
			
			num = qheight;
			numk = qwidth;
			

          for (i = 0; i < num; i++)
            {
                yt = i * qwidth;
                for (k = 0; k < numk; k++)
                {
                    qa = vecQuad[yt + k];
                    
                    //test on self
                    //debit += (qa.num * qa.num) / 2;
                    
                    if (qa.dirty > 0) { conQuad(qa); nconn += 1; }
                    
                    if (k < numk - 1)
                    {
                    qb = vecQuad[yt + k + 1];
                    
                    //test on right
                    //debit += (qa.num * qb.num);
                      if (qa.dirty > 0 || qb.dirty > 0) 
                        { conQuad2(qa, qb); nconn += 1; }
                    
                    }
                    
                    if (i < num -1)
                    {
                    qb = vecQuad[yt + k + qwidth];
  
                      if (qa.dirty > 0 || qb.dirty > 0) 
                        { conQuad2(qa, qb); nconn += 1; }
                    }
                    //debit += (qa.num * qb.num);
                
                }//nextk
            }//nexti
            
 
			//quads no longer dirty
			 num = vec.length;
			for (i = 0; i < num; i++)
			{
				a = vec[i];
				a.dirty = 0;
			}//nexti
			
			//clear global veczone of dead  (deleted) zones
			
			var m:xZone;
			
			num = vecZone.length;
			for (i = 0; i < num; i++)
			{
				m = vecZone[i];
				//reset group
				m.group = 0;
				if (m.dead == false) { continue; }
				
				vecZone[i] = vecZone[num - 1];
				num -= 1;
				i -= 1;
				vecZone.pop();
				
			}//nexti
    
  
			genGroup();
			 
			 
		}//rebuildquad
	
		
					
		



//		public function makeZoneQuad(qa:xQuad, vec:Vector.<int>, mw:int, mh:int,  cellw:Number=1.0, cellh:Number=1.0):void
	
      public function makeZoneQuad(qa:xQuad, tmap:xTileMap):void  
      {
		
          var ex:int;  var ey:int;
          var i:int;	 var k:int;	  var yt:int;
		      var a:xZone;
		      var vz:Vector.<xZone>;
          var zt:int;
          var t:int;
          var vec:Vector.<int>;
          var vecSet:Vector.<xTile>;
          var mw:int;     
          var mh:int;
          var cellw:Number;
          var cellh:Number;
          var tile:int;
      
          mw = tmap.mw;
          mh = tmap.mh;
          cellw = tmap.cw;
          cellh = tmap.ch;
          vec = tmap.vecGrid;
          vecSet = tmap.vecSet;

          ex = qa.tx + qcell;
          ey = qa.ty + qcell;
          
          if (ex > mw) { ex = mw;}
          if (ey > mh) { ey = mh;}

            vz = new Vector.<xZone>(0, false);
            qa.vec = vz;
            
            vecCol = new Vector.<int>(mw, false); //todo -- dont make everytime a new one (?)
            for (i = 0; i < mw; i++) { vecCol[i] = -2; }


var safe:int = 0;


                for (i = qa.ty; i < ey; i++)
                {

                 yt = i * mw;

                 for (k = qa.tx; k < ex; k++)
                 {
                    if (vecCol[k] > i) { continue; }    

                    zt = vecSet[vec[yt+k]].zt;
                    //zt = vec[yt+k];
                   // if (zt <= 0) { continue; } //0 is empty

                    //find next wall in line
                    for (k2 = k; k2 < ex; k2++)
                    {
                      t = vecSet[vec[yt+k2]].zt;
                      //t = vec[yt+k2];
                      if (vecCol[k2] > i) { break; } 
                      if (t != zt) { break; }
                    }

                    var ww:int;
                    var wh:int;
                    var ex2:int;  
                    var k2:int;
                    var i2:int;
                    var yt2:int;

                    ww = k2-k;
                    wh = 1;
                    ex2 = k2;  


                    //find the length of zone downwards
                    for (i2 = i+1; i2 <ey; i2++)
                    {          
                      yt2 = i2*mw;
                      for (k2 =k; k2 <ex2; k2++)
                      {
                         t = vecSet[vec[yt2+k2]].zt;
                         //t = vec[yt2+k2];
                         if (vecCol[k2] > i2) { break; } 
                         if (t != zt) { break;} 
                      }
                      if (k2 < ex2) { break; }
                      wh+=1;  
                    }

                    //set column for already visited ones
                    for (k2 = k; k2 < ex2; k2++)
                    {
                      vecCol[k2] = i+wh;
                    }
                          

                    a = new xZone();
                     a.cx = k*cellw;     a.cw = ww*cellw;
                     a.cy = i*cellh;     a.ch = wh*cellh;
                     a.group = 0;  a.col = 0xffffff*Math.random();
                     if (zt == 0) { a.col = 0xff0000;}
                     else {a.col = 0x0000ff; } 
                      a.zt = zt;

	
                      a.cx2 = a.cx + a.cw;
                      a.cy2 = a.cy + a.ch;
                      a.mx = a.cx + (a.cw * 0.5);
                      a.my = a.cy + (a.ch * 0.5);

        	          vz.push(a); //add to quadrant
                    vecZone.push(a); //add to global
                    

                    //infinite loop protection for now
                    safe += 1;
                    if (safe >= 128) { return;}                    
                    
                }//nextk
            }//nexti

		}//makezonequad



		
		
        
        public function drawZones(g:Graphics):void //Sprite
        {
          var i:int;
          var num:int;
          var a:xZone;
         // var sp:Sprite;
          var c:uint;
          
          c = 0;
         // sp = new Sprite();
         // sp.graphics.clear();
          g.lineStyle(2, 0xFF);
          
          num = vecZone.length;
          
          for (i = 0; i < num; i++)
          {
            a = vecZone[i];
            
            if (c != a.col) { c = a.col; g.lineStyle(2, c); }
            g.beginFill(c, 0.25);
            g.drawRect(a.cx, a.cy, a.cw, a.ch);
            g.endFill();            

                 //g.moveTo(a.cx, a.cy);
                 //g.lineTo(a.cx + a.cw, a.cy + a.ch);
		   
                
				        var k:int;
				        var numk:int;
				        var vk:Vector.<xZone>;
				        var o:xZone;
				        vk = a.vecNext;
				        numk = vk.length;
				
				        for (k = 0; k < numk; k++)
				        {
					        o = vk[k];
					        g.moveTo(o.mx, o.my);
					        g.lineTo(a.mx, a.my);
				        }//nextk
                        
          }//nexti
        
          //return sp;
        }//drawzone
        
        
        
        
        
	}//classend

}

internal class xQuad
{
    public var vec:Vector.<xZone> = new Vector.<xZone>(0, false);
    
    public var tx:int = 0;
    public var ty:int = 0;
    
    public var dirty:int = 0;
    
    public function clear():void
    {
        var i:int;
        var num:int;
        var a:xZone;
        
        num = vec.length;
        
        for (i = 0; i < num; i++)
        {
            a = vec[i];
            a.dead = true;
            
        }//nexti
        
        vec = null;  
    }//clear
    
    
    public function clean():void
    {
        var i:int;
        var num:int;
        var a:xZone;

        var numk:int;
        var k:int;
        var vk:Vector.<xZone>;
        var b:xZone;
        
        num = vec.length;
        
        for (i = 0; i < num; i++)
        {
            a = vec[i];
            
            vk = a.vecNext;
            numk = vk.length;
            
            for (k = 0; k < numk; k++)
            {
                b = vk[k];
                if (!b.dead) { continue; }
                vk[k] = vk[numk - 1];
                k -= 1;
                vk.pop();
                numk -= 1;
                
            }//nextk
            
        }//nexti
        
    }//clean
    
}//xquad


internal class xMegaRand
{
    
    public function xMegaRand(seed:int = 1) 	{ setSeed(seed);		}
		
		  //http://stackoverflow.com/questions/1046714/what-is-a-good-random-number-generator-for-a-game
 
		public var high:int = 1;
		public var low:int = 1 ^ 0x49616E42; 
		
		public function setSeed(seed:int):void
		{
			high = seed;
			low = seed ^ 0x49616E42;
		}//setseed 
		
		public function getRand():Number
		{
			high = (high >> 2) + (high << 2);
			high += low;
			low += high;
			
			var rand2:Number = (high % 32768) / 32768.0;
			if (rand2 < 0.0 ) { rand2 = -rand2; }
			if (rand2 > 1.0 ) { rand2 = 1.0; }

			return rand2;
		}//getrand 

    
    
    
    
}//xmegarand



/*
internal class xPoint
{
  public var cx:Number = 0;
  public var cy:Number = 0;
  
  public function xPoint(x:Number=0, y:Number=0)
  {
    cx = x;
    cy = y;
  }//ctor
  
}//xpoint
*/

/*
//todo -- rename it to something else (maybe put it in an other file)
internal class xZone
{
    public var cx:Number = 0;
    public var cy:Number = 0;
    public var cw:Number = 0;
    public var ch:Number = 0;
    
      public var mx:Number = 0;
      public var my:Number = 0;
    
    public var group:int = 0;
    
    public var col:uint = 0;
    
    public var cost:Number = 0;
    
    public var frame:int = 0; //if same as curframe we already checked this one (eliminating the closed array)
    
    public var parent:xZone = null; //used for building final path
    
    public var vecNext:Vector.<xZone> = new Vector.<xZone>(0,false);

}//xzone
*/
