package  
{
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.utils.Dictionary;
	import flash.display.BitmapData;
	import flash.display.Graphics;	
	import flash.geom.Point;
	import flash.geom.Rectangle;


	public class xTileMap 
	{
    public var cw:Number = 32;
    public var ch:Number = 32;
    public var icw:Number = 1/32;
    public var ich:Number = 1/32;    
    public var mw:int = 0;
    public var mh:int = 0;
    public var vecSet:Vector.<xTile>;
    public var vecGrid:Vector.<int>;
    //public var vecZt:Vector.<int>; //zone types
    //todo -- height?
    public var outWall:Boolean = true;

    public var tileMask:BitmapData;


    public function xTileMap()
    {
      vecSet = new Vector.<xTile>(1024, false);
      var i:int; var num:int;  
      num = vecSet.length;
      for (i = 0; i < num; i++) { vecSet[i] = new xTile(); }
    }//ctor



    public function initEmpty(w:int, h:int, cw_:Number=0, ch_:Number=0):void
    {
      mw = w;
      mh = h;
      cw = cw_;
      ch = ch_;
      vecGrid = new Vector.<int>(mw*mh, false);
      //vecZt = new Vector.<int>(mw*mh,false);
    }//empty



    public function setRect(ax:Number, ay:Number, aw:Number, ah:Number, c:int):void
    {
      setRect2(ax*icw, ay*ich, aw*icw, ah*ich, c);
    }//setrect



    public function setRect2(ax:int, ay:int, aw:int, ah:int, c:int):void
    {
      if (ax+aw < 0) { return; }
      if (ay+ah < 0) { return; }
      if (ax > mw) { return; }
      if (ay > mh) { return; }

      var i:int;
      var k:int;
      var yt:int;

      var sx:int;
      var sy:int;
      var ex:int;
      var ey:int;

      sx = ax;
      sy = ay;
      ex = sx+aw;
      ey = sy+ah;

      if (sx< 0) { sx = 0;}
      if (sy<0) {  sy = 0;}
      if (ex > mw) { ex = mw;}
      if (ey > mh) { ey = mh;}

      for (i = sy; i < ey; i++)
      {
        yt = i * mw;
        for (k = sx; k < ex; k++)
        {
          vecGrid[yt+k] = c;
        }//nextk    
      }//nexti

    }//setrect2
  

    public function getTset(tx:int, ty:int, tw:int):xTile
    {
      return vecSet[(ty * tw) + tx];
    }//gettset
    
    
    //doubles as tile data reset
    //todo - its assumed that the setpic is the same size as the mask
    public function setMaskPic(bm:BitmapData):void
    {
        tileMask = bm;
        
        var tilew:int;
        var tileh:int;
        var i:int;
        var k:int;
        var yt:int;
        var t:xTile;
        
        tilew = Math.floor(tileMask.width / 32);
        tileh = Math.floor(tileMask.height / 32);
        
        for (i = 0; i < tileh; i++)
        {
            yt = i * tilew;
            for (k = 0; k < tilew; k++)
            {
                t = vecSet[yt + k];
                t.maskx = k * cw;
                t.masky = i * ch;
                
                t.setRect.x = t.maskx;
                t.setRect.y = t.masky;
                t.setRect.width = cw;
                t.setRect.height = ch;
        
                t.disp = 1;
                t.wall = 0;
            }//nextk
        }//nexti
        
    }//setmaskpic
    
    
    public function getMask(wx:Number, wy:Number):uint
    {
        var tx:int;
        var ty:int;
        var ox:int;
        var oy:int;
       // var r:Rectangle;
        var a:xTile;
        var t:int;
        
        tx = wx * icw;
        ty = wy * ich;
        
        if (tx < 0) { return 0; }
        if (ty < 0) { return 0; }
        if (tx >= mw) { return 0; }
        if (ty >= mh) { return 0; }
        
        ox = (wx % cw);
        oy = (wy % ch);
        
        t = vecGrid[tx + (ty * mw)];
        
       // if (t <= 0) { return 0; }			
       // if (t >= maxTile) { return 0; }
        
      //  r = tileData.vecTile[t].maskRect;
 
        a = vecSet[t];
      
        //for 3D Y needs to be mirrored vertically -- because the whole map is mirrored on y
       // return tileMask.getPixel(a.maskx + ox, a.masky + (ch-oy));
          return tileMask.getPixel(a.maskx + ox, a.masky + oy);
    }//getmask
    
    
   
   
    public function getWallNum(wx:Number, wy:Number):int
    {
      var tx:int;
      var ty:int;
        
      tx = (wx*icw)|0;
      ty = (wy*ich)|0;

      if (tx < 0) { return 0; }
      if (ty < 0) { return 0; }
      if (tx >= mw) { return 0; }
      if (ty >= mh) { return 0; }

      return vecSet[vecGrid[(ty * mw) + tx]].wall;
    }//setwall
    

    public function setWall(wx:Number, wy:Number, c:int):void
    {
      var tx:int;
      var ty:int;
        
      tx = (wx*icw)|0;
      ty = (wy*ich)|0;

      if (tx < 0) { return; }
      if (ty < 0) { return; }
      if (tx >= mw) { return; }
      if (ty >= mh) { return; }

      vecGrid[(ty*mw)+tx] = c;
    }//setwall


    public function setWall2(tx:int, ty:int, c:int):void
    {
      if (tx < 0) { return; }
      if (ty < 0) { return; }
      if (tx >= mw) { return; }
      if (ty >= mh) { return; }

      vecGrid[(ty*mw)+tx] = c;
    }//setwall


    public function isWall(wx:Number, wy:Number):Boolean
    {
      var tx:int;
      var ty:int;
        
      tx = (wx*icw)|0;
      ty = (wy*ich)|0;

      if (tx < 0) { return outWall; }
      if (ty < 0) { return outWall; }
      if (tx >= mw) { return outWall; }
      if (ty >= mh) { return outWall; }

      return (vecSet[vecGrid[(ty*mw)+tx]].wall >0);
    }//iswall



    public function isWall2(tx:int, ty:int):Boolean
    {      
      if (tx < 0) { return outWall; }
      if (ty < 0) { return outWall; }
      if (tx >= mw) { return outWall; }
      if (ty >= mh) { return outWall; }

      return (vecSet[vecGrid[(ty*mw)+tx]].wall >0);
    }//iswall2

  

    //todo -- outtile
    public function getTile(wx:Number, wy:Number):xTile
    {
      var tx:int;
      var ty:int;
        
      tx = (wx*icw)|0;
      ty = (wy*ich)|0;

      if (tx < 0) { return null; }
      if (ty < 0) { return null; }
      if (tx >= mw) { return null; }
      if (ty >= mh) { return null; }

      return (vecSet[vecGrid[(ty*mw)+tx]]);
    }//gettile



    public function getTile2(tx:int, ty:int):xTile
    {
      if (tx < 0) { return null; }
      if (ty < 0) { return null; }
      if (tx >= mw) { return null; }
      if (ty >= mh) { return null; }

      return (vecSet[vecGrid[(ty*mw)+tx]]);
    }//gettile2

    /*
    public var tempMat:Vector.<Number> = Vector.<Number>([
    1, 0, 0, 0,
    0, 1, 0, 0,
    0, 0, 1, 0,
    0, 0, 0, 1 ]);
    public function meshRender(ax:int, ay:int, aw:int, ah:int, drawz:Number, rend:xRender):void
    {
      var k:int;
      var i:int;
      var yt:int;
      var t:int;
      var a:xTile;
      var mat:Vector.<Number>;
      var ex:int;
      var ey:int;
      var mesh:xMdx;
      
      ex = ax + aw;
      ey = ay + ah;
      
      if (ax < 0) { ax = 0; }
      if (ay < 0) { ay = 0; }
      if (ax >= mw) { return; }
      if (ay >= mh) { return; }
      if (ex < 0) { return; }
      if (ey < 0) { return; }
      if (ex > mw) { ex = mw; }
      if (ey > mh) { ey = mh; }
      
      mat = tempMat;

      mat[14] = drawz;
      
      for (i = ay; i < ey; i++)
      {
        yt = i * mw;
        mat[13] = i * ch;
        for (k = ax; k < ex; k++)
        {
          t = vecGrid[yt+k];
          if (t <= 0) { continue; }
          a = vecSet[t];
          if (a.disp <= 0) { continue; }
          if (a.mesh == null) { continue; }

            mat[12] = k * cw;
            mesh = a.mesh;
            rend.addMesh2(mesh.numFace, mesh.vecFace, mesh.vecVert, mesh.vecUv, mat, a.skin,0,-1,8,0,1);
        }//nextk
      }//nexti
      
      
    }//meshrender
    */
    
    
  

    
    public function debRender2(g:Graphics, ax:int, ay:int,aw:int,ah:int,ox:Number,oy:Number):void
    {
      var k:int;
      var i:int;
      var yt:int;
      var t:int;
      var a:xTile;
      var ex:int;
      var ey:int;
 
      ex = ax + aw;
      ey = ay + ah;
      
      if (ax < 0) { ax = 0; }
      if (ay < 0) { ay = 0; }
      if (ax >= mw) { return; }
      if (ay >= mh) { return; }
      if (ex < 0) { return; }
      if (ey < 0) { return; }
      if (ex > mw) { ex = mw; }
      if (ey > mh) { ey = mh; }
      
      
      
       for (i = ay; i < ey; i++)
      {
        yt = i * mw;
        for (k = ax; k < ex; k++)
        {
          t = vecGrid[yt+k];
          if (t <= 0) { continue; }
          a = vecSet[t];
          if (a.disp <= 0) { continue; }
          g.beginFill(a.color,1)
            g.drawRect(ox+k*cw,oy+i*ch,cw,ch);
          g.endFill();
        }//nextk
      }//nexti
    }//debugdraw

    

    //draw the whole map -- only good for debugging
    public function debRender(g:Graphics):void
    {
      var k:int;
      var i:int;
      var yt:int;
      var t:int;
      var a:xTile;

      for (i = 0; i < mh; i++)
      {
        yt = i * mw;
        for (k = 0; k < mw; k++)
        {
          t = vecGrid[yt+k];
          if (t <= 0) { continue; }
          a = vecSet[t];
          if (a.disp <= 0) { continue; }
          g.beginFill(a.color,1)
            g.drawRect(k*cw,i*ch,cw,ch);
          g.endFill();
        }//nextk
      }//nexti
    }//debugdraw
    
    
    public function mirrorVert():void
    {
      var temp:Vector.<int>;
      var i:int;
      var k:int;
      var yt:int;
      var yt2:int;
      
      temp = new Vector.<int>(vecGrid.length, false);
      
      for (i = 0; i < mh; i++)
      {
        yt = i * mw;
        yt2 = ((mh - i) - 1) * mw;
        for (k = 0; k < mw; k++)
        {
            temp[yt2 + k] = vecGrid[yt + k];
        }//nextyt
      }//nexti
      
      vecGrid = temp;
    }//mirvert
    
    
    
    
    
    
    
    
    
    
    public function drawTileMap(to:BitmapData, tset:BitmapData, cx:Number, cy:Number):void
        {
            var sx:int;
            var sy:int;
            var ex:int;
            var ey:int;
            var w:Number;
            var h:Number;
            
            w = to.width;
            h = to.height;
            
            sx = Math.floor(cx*icw);
            sy = Math.floor(cy*ich);
            ex = sx + Math.ceil(w*icw)+1;
            ey = sy + Math.ceil(h*ich)+1;

            drawTmap(to, tset, cx, cy, sx, sy, ex, ey);
			
        }//drawTileMap

    
    
      public var tempPoint:Point = new Point();
      protected function drawTmap(to:BitmapData, tset:BitmapData, cx:Number, cy:Number,
        sx:int, sy:int, ex:int, ey:int):void
        {
            var i:int;
            var k:int;
            var yt:int;
            var t:int;
            var wt:Rectangle;
            var dp:Point;
            var s:xTile;
            
			      var vec:Vector.<xTile>;
			      var a:xTile;
			      //var numTile:int;
			      //var bmTile:BitmapData
			
            if (sy < 0) { sy = 0;}
            if (sy >= mh) { return; }
            if (sx < 0) { sx = 0;}
            if (sx >= mw) { return;}
            
            if (ex < 0) { return; }
            if (ex > mw) { ex = mw;}
            if (ey < 0) { return; }
            if (ey > mh) { ey = mh; } 
			
              dp = tempPoint;
			        vec = vecSet;
			       // bmTile = tdata.pic;
			       // numTile = tdata.numTile;
            
            for ( i = sy; i < ey; i++)
            {
                yt = i * mw;
                
                for (k = sx; k < ex; k++)
                {
                    t = vecGrid[yt+k];
                    if (t <= 0) { continue; }
                    s = vecSet[t];
                    if (s.disp <= 0) { continue; }
                    //if ( t >= numTile) { continue;} 
                    //if (vec[t].visible <= 0) { continue; } //tile not visible
                        
                       dp.x = (k*cw)-cx;
                       dp.y = (i*ch)-cy;
                         
                       wt = vec[t].setRect;
                       to.copyPixels(tset, wt, dp); 

                }//nextk
            }//nexti
        }//drawbmap

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
   
  }//classend


}
